<?php

namespace ByDedi\Module\CustomForm\Model;

use Model;

/**
 * Class FormResponse
 *
 * @property int $form_response_id
 * @property int $boutique_id
 * @property int form_id
 * @property string $form_response_ip
 */
class FormResponse extends Model
{
    protected $table = 'form_response';

    /**
     * @var FormResponseField[]
     */
    protected $fields = [];

    /**
     * @return int
     */
    public function getFormId()
    {
        return $this->form_id;
    }

    /**
     * @param int $form_id
     * @return FormResponse
     */
    public function setFormId($form_id)
    {
        $this->form_id = $form_id;
        return $this;
    }

    /**
     * @return string
     */
    public function getFormResponseIp()
    {
        return $this->form_response_ip;
    }

    /**
     * @param string $form_response_ip
     * @return FormResponse
     */
    public function setFormResponseIp($form_response_ip)
    {
        $this->form_response_ip = $form_response_ip;
        return $this;
    }

    /**
     * @return int
     */
    public function getBoutiqueId()
    {
        return $this->boutique_id;
    }

    /**
     * @param int $boutique_id
     * @return FormResponse
     */
    public function setBoutiqueId($boutique_id)
    {
        $this->boutique_id = $boutique_id;
        return $this;
    }

    /**
     * @return int
     */
    public function getFormResponseId()
    {
        return $this->form_response_id;
    }

    /**
     * @param int $form_response_id
     * @return FormResponse
     */
    public function setFormResponseId($form_response_id)
    {
        $this->form_response_id = $form_response_id;
        return $this;
    }

    /**
     * @return FormResponseField[]
     */
    public function getFields()
    {
        return $this->fields;
    }

    /**
     * @param FormResponseField $field
     * @return FormResponse
     */
    public function addField(FormResponseField $field)
    {
        $this->fields[] = $field;
        return $this;
    }

    public function save($data = null)
    {
        $id = parent::save($data);
        $this->setFormResponseId($id);

        array_walk($this->getFields(), function (FormResponseField $field) {
            $field->setFormResponseId($this->getFormResponseId());
            $field->save();
        });
    }
}