<?php
/**
 * Created by PhpStorm.
 * User: gabriel
 * Date: 24/05/18
 * Time: 13:10
 */

namespace ByDedi\Module\CustomForm\Service\Component;


use CustomForm\Model\FormField;
use Form\Field as FieldMaster;

class Field extends FieldMaster
{
    /**
     * @var array[]
     */
    protected $options = [];

    /**
     * @var FormField
     */
    protected $formField;

    public function __construct($name, FormField $formField)
    {
        parent::__construct($name);
        $this->setFormField($formField);
    }

    /**
     * @return array[]
     */
    public function getOptions()
    {
        return $this->options;
    }

    /**
     * @param array[] $options
     * @return Field
     */
    public function setOptions($options)
    {
        $this->options = $options;
        return $this;
    }

    public function hasOptions()
    {
        return $this->getFormField()->hasOptions();
    }

    public function getOptionByValue($value)
    {
        foreach ($this->getOptions() as $option) {
            if ($option['form_field_option_value'] == $value) {
                return $option;
            }
        }

        // TODO precise
        throw new \Exception();
    }

    /**
     * @return FormField
     */
    public function getFormField()
    {
        return $this->formField;
    }

    /**
     * @param FormField $formField
     * @return Field
     */
    public function setFormField($formField)
    {
        $this->formField = $formField;
        return $this;
    }
}