<?php

namespace ByDedi\Module\CustomForm\Service;

use Exception;
use Throwable;

class InvalidFormRequestException extends Exception
{
    /**
     * @var string[]
     */
    protected $errors = [];

    public function __construct(array $errors, $message = "", $code = 0, Throwable $previous = null)
    {
        $this->setErrors($errors);
        parent::__construct($message, $code, $previous);
    }

    /**
     * @return string[]
     */
    public function getErrors()
    {
        return $this->errors;
    }

    /**
     * @param string[] $errors
     * @return InvalidFormRequestException
     */
    public function setErrors($errors)
    {
        $this->errors = $errors;
        return $this;
    }
}