<?php
/**
 * Created by PhpStorm.
 * User: gabriel
 * Date: 24/05/18
 * Time: 13:59
 */

namespace CustomForm\Service;


use Boutique;
use ByDedi\Module\CustomForm\Model\FormResponse;
use ByDedi\Module\CustomForm\Model\FormResponseField;
use ByDedi\Module\CustomForm\Service\Component\Field;
use ByDedi\Module\CustomForm\Service\Component\Form;
use Symfony\Component\HttpFoundation\Request;

class ResponseFactory
{
    public function generate(Request $request, Form $form)
    {
        $response = new FormResponse();
        $form->handle($request);

        $response
            ->setBoutiqueId(Boutique::getInstance()->id)
            ->setFormId($form->getFormModel()->getFormId())
            ->setFormResponseIp($request->getClientIp())
        ;

        $fields = $form->getFields();

        array_walk($fields, function (Field $field) use ($request, $response) {
            $value = $request->get($field->getName(), '');
            $responseField = new FormResponseField();
            $responseField
                ->setFormFieldResponseValue($value)
                ->setFormFieldId($field->getFormField()->getFormFieldId())
            ;

            if (!empty($value) && $field->hasOptions()) {
                $option = $field->getOptionByValue($value);
                if (!empty($option)) {
                    $responseField->setFormFieldOptionId($option['form_field_option_id']);
                }
            }
            $response->addField($responseField);
        });

        return $response;
    }
}